#ifndef Lib_ColumnsLexer_h
#define Lib_ColumnsLexer_h 

namespace Slash {namespace Core {class IWriter;}}

#include <vector>
#include <string>

namespace Lib {

class ColumnsLexer {
public:
  ColumnsLexer(Slash::Core::IWriter&,int = 0);
  ColumnsLexer& operator=(const ColumnsLexer&);
  void set(const std::string&);
  std::vector<std::string>& variables();
  const std::string& variable(unsigned int) const;
  Slash::Core::IWriter& printer() const;
  int verboseLevel() const;
public:
  static int input(char*,int); // Can't be avoided.
private:
  int fVerboseLevel;
  std::string fString;
  char* fCurrent;
  char* fEnd;
  std::vector<std::string> fVariables;
  Slash::Core::IWriter& fPrinter;
};

}

#endif
